diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/RequestMethod/SocketPost.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/RequestMethod/SocketPost.php
new file mode 100644
index 00000000..47541215
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/RequestMethod/SocketPost.php
@@ -0,0 +1,121 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha\RequestMethod;
+
+use ReCaptcha\RequestMethod;
+use ReCaptcha\RequestParameters;
+
+/**
+ * Sends a POST request to the reCAPTCHA service, but makes use of fsockopen()
+ * instead of get_file_contents(). This is to account for people who may be on
+ * servers where allow_furl_open is disabled.
+ */
+class SocketPost implements RequestMethod
+{
+    /**
+     * reCAPTCHA service host.
+     * @const string
+     */
+    const RECAPTCHA_HOST = 'www.google.com';
+
+    /**
+     * @const string reCAPTCHA service path
+     */
+    const SITE_VERIFY_PATH = '/recaptcha/api/siteverify';
+
+    /**
+     * @const string Bad request error
+     */
+    const BAD_REQUEST = '{"success": false, "error-codes": ["invalid-request"]}';
+
+    /**
+     * @const string Bad response error
+     */
+    const BAD_RESPONSE = '{"success": false, "error-codes": ["invalid-response"]}';
+
+    /**
+     * Socket to the reCAPTCHA service
+     * @var Socket
+     */
+    private $socket;
+
+    /**
+     * Constructor
+     *
+     * @param \ReCaptcha\RequestMethod\Socket $socket optional socket, injectable for testing
+     */
+    public function __construct(Socket $socket = null)
+    {
+        if (!is_null($socket)) {
+            $this->socket = $socket;
+        } else {
+            $this->socket = new Socket();
+        }
+    }
+
+    /**
+     * Submit the POST request with the specified parameters.
+     *
+     * @param RequestParameters $params Request parameters
+     * @return string Body of the reCAPTCHA response
+     */
+    public function submit(RequestParameters $params)
+    {
+        $errno = 0;
+        $errstr = '';
+
+        if (false === $this->socket->fsockopen('ssl://' . self::RECAPTCHA_HOST, 443, $errno, $errstr, 30)) {
+            return self::BAD_REQUEST;
+        }
+
+        $content = $params->toQueryString();
+
+        $request = "POST " . self::SITE_VERIFY_PATH . " HTTP/1.1\r\n";
+        $request .= "Host: " . self::RECAPTCHA_HOST . "\r\n";
+        $request .= "Content-Type: application/x-www-form-urlencoded\r\n";
+        $request .= "Content-length: " . strlen($content) . "\r\n";
+        $request .= "Connection: close\r\n\r\n";
+        $request .= $content . "\r\n\r\n";
+
+        $this->socket->fwrite($request);
+        $response = '';
+
+        while (!$this->socket->feof()) {
+            $response .= $this->socket->fgets(4096);
+        }
+
+        $this->socket->fclose();
+
+        if (0 !== strpos($response, 'HTTP/1.1 200 OK')) {
+            return self::BAD_RESPONSE;
+        }
+
+        $parts = preg_split("#\n\s*\n#Uis", $response);
+
+        return $parts[1];
+    }
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/RequestParameters.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/RequestParameters.php
new file mode 100644
index 00000000..cb66f26c
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/RequestParameters.php
@@ -0,0 +1,103 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha;
+
+/**
+ * Stores and formats the parameters for the request to the reCAPTCHA service.
+ */
+class RequestParameters
+{
+    /**
+     * Site secret.
+     * @var string
+     */
+    private $secret;
+
+    /**
+     * Form response.
+     * @var string
+     */
+    private $response;
+
+    /**
+     * Remote user's IP address.
+     * @var string
+     */
+    private $remoteIp;
+
+    /**
+     * Client version.
+     * @var string
+     */
+    private $version;
+
+    /**
+     * Initialise parameters.
+     *
+     * @param string $secret Site secret.
+     * @param string $response Value from g-captcha-response form field.
+     * @param string $remoteIp User's IP address.
+     * @param string $version Version of this client library.
+     */
+    public function __construct($secret, $response, $remoteIp = null, $version = null)
+    {
+        $this->secret = $secret;
+        $this->response = $response;
+        $this->remoteIp = $remoteIp;
+        $this->version = $version;
+    }
+
+    /**
+     * Array representation.
+     *
+     * @return array Array formatted parameters.
+     */
+    public function toArray()
+    {
+        $params = array('secret' => $this->secret, 'response' => $this->response);
+
+        if (!is_null($this->remoteIp)) {
+            $params['remoteip'] = $this->remoteIp;
+        }
+
+        if (!is_null($this->version)) {
+            $params['version'] = $this->version;
+        }
+
+        return $params;
+    }
+
+    /**
+     * Query string representation for HTTP request.
+     *
+     * @return string Query string formatted parameters.
+     */
+    public function toQueryString()
+    {
+        return http_build_query($this->toArray(), '', '&');
+    }
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/Response.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/Response.php
new file mode 100644
index 00000000..d2d8a8bf
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/ReCaptcha/Response.php
@@ -0,0 +1,102 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha;
+
+/**
+ * The response returned from the service.
+ */
+class Response
+{
+    /**
+     * Succes or failure.
+     * @var boolean
+     */
+    private $success = false;
+
+    /**
+     * Error code strings.
+     * @var array
+     */
+    private $errorCodes = array();
+
+    /**
+     * Build the response from the expected JSON returned by the service.
+     *
+     * @param string $json
+     * @return \ReCaptcha\Response
+     */
+    public static function fromJson($json)
+    {
+        $responseData = json_decode($json, true);
+
+        if (!$responseData) {
+            return new Response(false, array('invalid-json'));
+        }
+
+        if (isset($responseData['success']) && $responseData['success'] == true) {
+            return new Response(true);
+        }
+
+        if (isset($responseData['error-codes']) && is_array($responseData['error-codes'])) {
+            return new Response(false, $responseData['error-codes']);
+        }
+
+        return new Response(false);
+    }
+
+    /**
+     * Constructor.
+     *
+     * @param boolean $success
+     * @param array $errorCodes
+     */
+    public function __construct($success, array $errorCodes = array())
+    {
+        $this->success = $success;
+        $this->errorCodes = $errorCodes;
+    }
+
+    /**
+     * Is success?
+     *
+     * @return boolean
+     */
+    public function isSuccess()
+    {
+        return $this->success;
+    }
+
+    /**
+     * Get error codes.
+     *
+     * @return array
+     */
+    public function getErrorCodes()
+    {
+        return $this->errorCodes;
+    }
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/autoload.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/autoload.php
new file mode 100644
index 00000000..a53cbd78
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/src/autoload.php
@@ -0,0 +1,38 @@
+<?php
+
+/* An autoloader for ReCaptcha\Foo classes. This should be require()d
+ * by the user before attempting to instantiate any of the ReCaptcha
+ * classes.
+ */
+
+spl_autoload_register(function ($class) {
+    if (substr($class, 0, 10) !== 'ReCaptcha\\') {
+      /* If the class does not lie under the "ReCaptcha" namespace,
+       * then we can exit immediately.
+       */
+      return;
+    }
+
+    /* All of the classes have names like "ReCaptcha\Foo", so we need
+     * to replace the backslashes with frontslashes if we want the
+     * name to map directly to a location in the filesystem.
+     */
+    $class = str_replace('\\', '/', $class);
+
+    /* First, check under the current directory. It is important that
+     * we look here first, so that we don't waste time searching for
+     * test classes in the common case.
+     */
+    $path = dirname(__FILE__).'/'.$class.'.php';
+    if (is_readable($path)) {
+        require_once $path;
+    }
+
+    /* If we didn't find what we're looking for already, maybe it's
+     * a test class?
+     */
+    $path = dirname(__FILE__).'/../tests/'.$class.'.php';
+    if (is_readable($path)) {
+        require_once $path;
+    }
+});
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/ReCaptchaTest.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/ReCaptchaTest.php
new file mode 100644
index 00000000..dbbfc992
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/ReCaptchaTest.php
@@ -0,0 +1,75 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha;
+
+class ReCaptchaTest extends \PHPUnit_Framework_TestCase
+{
+
+    /**
+     * @expectedException \RuntimeException
+     * @dataProvider invalidSecretProvider
+     */
+    public function testExceptionThrownOnInvalidSecret($invalid)
+    {
+        $rc = new ReCaptcha($invalid);
+    }
+
+    public function invalidSecretProvider()
+    {
+        return array(
+            array(''),
+            array(null),
+            array(0),
+            array(new \stdClass()),
+            array(array()),
+        );
+    }
+
+    public function testVerifyReturnsErrorOnMissingResponse()
+    {
+        $rc = new ReCaptcha('secret');
+        $response = $rc->verify('');
+        $this->assertFalse($response->isSuccess());
+        $this->assertEquals(array('missing-input-response'), $response->getErrorCodes());
+    }
+
+    public function testVerifyReturnsResponse()
+    {
+        $method = $this->getMock('\\ReCaptcha\\RequestMethod', array('submit'));
+        $method->expects($this->once())
+                ->method('submit')
+                ->with($this->callback(function ($params) {
+
+                            return true;
+                        }))
+                ->will($this->returnValue('{"success": true}'));
+        ;
+        $rc = new ReCaptcha('secret', $method);
+        $response = $rc->verify('response');
+        $this->assertTrue($response->isSuccess());
+    }
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/CurlPostTest.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/CurlPostTest.php
new file mode 100644
index 00000000..892e207c
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/CurlPostTest.php
@@ -0,0 +1,63 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha\RequestMethod;
+
+use \ReCaptcha\RequestParameters;
+
+class CurlPostTest extends \PHPUnit_Framework_TestCase
+{
+
+    protected function setUp()
+    {
+        if (!extension_loaded('curl')) {
+            $this->markTestSkipped(
+                    'The cURL extension is not available.'
+            );
+        }
+    }
+
+    public function testSubmit()
+    {
+        $curl = $this->getMock('\\ReCaptcha\\RequestMethod\\Curl',
+                array('init', 'setoptArray', 'exec', 'close'));
+        $curl->expects($this->once())
+                ->method('init')
+                ->willReturn(new \stdClass);
+        $curl->expects($this->once())
+                ->method('setoptArray')
+                ->willReturn(true);
+        $curl->expects($this->once())
+                ->method('exec')
+                ->willReturn('RESPONSEBODY');
+        $curl->expects($this->once())
+                ->method('close');
+
+        $pc = new CurlPost($curl);
+        $response = $pc->submit(new RequestParameters("secret", "response"));
+        $this->assertEquals('RESPONSEBODY', $response);
+    }
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/PostTest.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/PostTest.php
new file mode 100644
index 00000000..2eaabb5c
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/PostTest.php
@@ -0,0 +1,118 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha\RequestMethod;
+
+use ReCaptcha\RequestParameters;
+
+class PostTest extends \PHPUnit_Framework_TestCase
+{
+    public static $assert = null;
+    protected $parameters = null;
+    protected $runcount = 0;
+
+    public function setUp()
+    {
+        $this->parameters = new RequestParameters("secret", "response", "remoteip", "version");
+    }
+
+    public function tearDown()
+    {
+        self::$assert = null;
+    }
+
+    public function testHTTPContextOptions()
+    {
+        $req = new Post();
+        self::$assert = array($this, "httpContextOptionsCallback");
+        $req->submit($this->parameters);
+        $this->assertEquals(1, $this->runcount, "The assertion was ran");
+    }
+
+    public function testSSLContextOptions()
+    {
+        $req = new Post();
+        self::$assert = array($this, "sslContextOptionsCallback");
+        $req->submit($this->parameters);
+        $this->assertEquals(1, $this->runcount, "The assertion was ran");
+    }
+
+    public function httpContextOptionsCallback(array $args)
+    {
+        $this->runcount++;
+        $this->assertCommonOptions($args);
+
+        $options = stream_context_get_options($args[2]);
+        $this->assertArrayHasKey('http', $options);
+
+        $this->assertArrayHasKey('method', $options['http']);
+        $this->assertEquals("POST", $options['http']['method']);
+
+        $this->assertArrayHasKey('content', $options['http']);
+        $this->assertEquals($this->parameters->toQueryString(), $options['http']['content']);
+
+        $this->assertArrayHasKey('header', $options['http']);
+        $headers = array(
+            "Content-type: application/x-www-form-urlencoded",
+        );
+        foreach ($headers as $header) {
+            $this->assertContains($header, $options['http']['header']);
+        }
+    }
+
+    public function sslContextOptionsCallback(array $args)
+    {
+        $this->runcount++;
+        $this->assertCommonOptions($args);
+
+        $options = stream_context_get_options($args[2]);
+        $this->assertArrayHasKey('http', $options);
+        $this->assertArrayHasKey('verify_peer', $options['http']);
+        $this->assertTrue($options['http']['verify_peer']);
+
+        $key = version_compare(PHP_VERSION, "5.6.0", "<") ? "CN_name" : "peer_name";
+
+        $this->assertArrayHasKey($key, $options['http']);
+        $this->assertEquals("www.google.com", $options['http'][$key]);
+    }
+
+    protected function assertCommonOptions(array $args)
+    {
+        $this->assertCount(3, $args);
+        $this->assertStringStartsWith("https://www.google.com/", $args[0]);
+        $this->assertFalse($args[1]);
+        $this->assertTrue(is_resource($args[2]), "The context options should be a resource");
+    }
+}
+
+function file_get_contents()
+{
+    if (PostTest::$assert) {
+        return call_user_func(PostTest::$assert, func_get_args());
+    }
+    // Since we can't represent maxlen in userland...
+    return call_user_func_array('file_get_contents', func_get_args());
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/SocketPostTest.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/SocketPostTest.php
new file mode 100644
index 00000000..10eb7c28
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestMethod/SocketPostTest.php
@@ -0,0 +1,90 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha\RequestMethod;
+
+use ReCaptcha\RequestParameters;
+
+class SocketPostTest extends \PHPUnit_Framework_TestCase
+{
+
+    public function testSubmitSuccess()
+    {
+        $socket = $this->getMock('\\ReCaptcha\\RequestMethod\\Socket', array('fsockopen', 'fwrite', 'fgets', 'feof', 'fclose'));
+        $socket->expects($this->once())
+                ->method('fsockopen')
+                ->willReturn(true);
+        $socket->expects($this->once())
+                ->method('fwrite');
+        $socket->expects($this->once())
+                ->method('fgets')
+                ->willReturn("HTTP/1.1 200 OK\n\nRESPONSEBODY");
+        $socket->expects($this->exactly(2))
+                ->method('feof')
+                ->will($this->onConsecutiveCalls(false, true));
+        $socket->expects($this->once())
+                ->method('fclose')
+                ->willReturn(true);
+
+        $ps = new SocketPost($socket);
+        $response = $ps->submit(new RequestParameters("secret", "response", "remoteip", "version"));
+        $this->assertEquals('RESPONSEBODY', $response);
+    }
+
+    public function testSubmitBadResponse()
+    {
+        $socket = $this->getMock('\\ReCaptcha\\RequestMethod\\Socket', array('fsockopen', 'fwrite', 'fgets', 'feof', 'fclose'));
+        $socket->expects($this->once())
+                ->method('fsockopen')
+                ->willReturn(true);
+        $socket->expects($this->once())
+                ->method('fwrite');
+        $socket->expects($this->once())
+                ->method('fgets')
+                ->willReturn("HTTP/1.1 500 NOPEn\\nBOBBINS");
+        $socket->expects($this->exactly(2))
+                ->method('feof')
+                ->will($this->onConsecutiveCalls(false, true));
+        $socket->expects($this->once())
+                ->method('fclose')
+                ->willReturn(true);
+
+        $ps = new SocketPost($socket);
+        $response = $ps->submit(new RequestParameters("secret", "response", "remoteip", "version"));
+        $this->assertEquals(SocketPost::BAD_RESPONSE, $response);
+    }
+
+    public function testSubmitBadRequest()
+    {
+        $socket = $this->getMock('\\ReCaptcha\\RequestMethod\\Socket', array('fsockopen'));
+        $socket->expects($this->once())
+                ->method('fsockopen')
+                ->willReturn(false);
+        $ps = new SocketPost($socket);
+        $response = $ps->submit(new RequestParameters("secret", "response", "remoteip", "version"));
+        $this->assertEquals(SocketPost::BAD_REQUEST, $response);
+    }
+}
diff --git a/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestParametersTest.php b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestParametersTest.php
new file mode 100644
index 00000000..adc601b4
--- /dev/null
+++ b/drupal7/sites/all/modules/recaptcha/recaptcha-php/tests/ReCaptcha/RequestParametersTest.php
@@ -0,0 +1,61 @@
+<?php
+/**
+ * This is a PHP library that handles calling reCAPTCHA.
+ *
+ * @copyright Copyright (c) 2015, Google Inc.
+ * @link      http://www.google.com/recaptcha
+ *
+ * Permission is hereby granted, free of charge, to any person obtaining a copy
+ * of this software and associated documentation files (the "Software"), to deal
+ * in the Software without restriction, including without limitation the rights
+ * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
+ * copies of the Software, and to permit persons to whom the Software is
+ * furnished to do so, subject to the following conditions:
+ *
+ * The above copyright notice and this permission notice shall be included in
+ * all copies or substantial portions of the Software.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
+ * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
+ * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
+ * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
+ * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
+ * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
+ * THE SOFTWARE.
+ */
+
+namespace ReCaptcha;
+
+class RequestParametersTest extends \PHPUnit_Framework_TestCase
+{
+
+    public function provideValidData()
+    {
+        return array(
+            array('SECRET', 'RESPONSE', 'REMOTEIP', 'VERSION',
+                array('secret' => 'SECRET', 'response' => 'RESPONSE', 'remoteip' => 'REMOTEIP', 'version' => 'VERSION'),
+                'secret=SECRET&response=RESPONSE&remoteip=REMOTEIP&version=VERSION'),
+            array('SECRET', 'RESPONSE', null, null,
+                array('secret' => 'SECRET', 'response' => 'RESPONSE'),
+                'secret=SECRET&response=RESPONSE'),
+        );
+    }
+
+    /**
+     * @dataProvider provideValidData
+     */
+    public function testToArray($secret, $response, $remoteIp, $version, $expectedArray, $expectedQuery)
+    {
+        $params = new RequestParameters($secret, $response, $remoteIp, $version);
+        $this->assertEquals($params->toArray(), $expectedArray);
+    }
+
+    /**
+     * @dataProvider provideValidData
+     */
+    public function testToQueryString($secret, $response, $remoteIp, $version, $expectedArray, $expectedQuery)
+    {
+        $params = new RequestParameters($secret, $response, $remoteIp, $version);
+        $this->assertEquals($params->toQueryString(), $expectedQuery);
+    }
+}
